"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const brolog_1 = require("brolog");
const messaging_sidecar_js_1 = require("./messaging-sidecar.js");
brolog_1.log.level('verbose');
async function main() {
    const sidecar = new messaging_sidecar_js_1.MessagingSidecar();
    process.on('SIGINT', () => sidecar.stop().catch(console.error));
    process.on('SIGTERM', () => sidecar.stop().catch(console.error));
    await sidecar.init();
    await sidecar.start();
    sidecar.on('hook', payload => {
        console.log('MessagingSidecar event[hook]:', payload);
    });
    await sidecar.mo('hello from MessagingSidecar!');
}
main()
    .catch(console.error);
//# sourceMappingURL=sidecar.js.map