#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const chatbox_sidecar_js_1 = require("../../examples/chatbox-sidecar.js");
const metadata_sidecar_js_1 = require("../decorators/sidecar/metadata-sidecar.js");
// import { Call, RetType, Sidecar } from '../decorators/mod.js'
// import { sidecarMetadata } from '../decorators/sidecar/sidecar-metadata.js'
// import { Ret } from '../ret.js'
// import { SidecarBody } from '../sidecar-body/sidecar-body.js'
const build_agent_source_js_1 = require("./build-agent-source.js");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
(0, tstest_1.test)('buildAgentSource() from fixture', async (t) => {
    const metadata = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    const source = await (0, build_agent_source_js_1.buildAgentSource)(metadata);
    // console.log(source)
    t.ok(source, 'ok (tbw)');
});
(0, tstest_1.test)('buildAgentSource() from example demo', async (t) => {
    const metadata = (0, metadata_sidecar_js_1.getMetadataSidecar)(chatbox_sidecar_js_1.ChatboxSidecar);
    // console.log(JSON.stringify(view, null, 2))
    const source = await (0, build_agent_source_js_1.buildAgentSource)(metadata);
    // console.log(source)
    t.ok(source, 'ok');
});
//# sourceMappingURL=build-agent-source.spec.js.map