#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const ret_js_1 = require("../../ret.js");
const call_js_1 = require("./call.js");
const metadata_call_js_1 = require("./metadata-call.js");
const constants_js_1 = require("./constants.js");
(0, tstest_1.test)('Call with metadata', async (t) => {
    var _a;
    const TARGET = 0x42;
    const METHOD_NAME = 'testMethod';
    class Test {
        [_a = METHOD_NAME]() { return (0, ret_js_1.Ret)(); }
    }
    __decorate([
        (0, call_js_1.Call)(TARGET),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Test.prototype, _a, null);
    const instance = new Test();
    const data = Reflect.getMetadata(constants_js_1.CALL_SYMBOL, instance, METHOD_NAME);
    /* eslint-disable no-sparse-arrays */
    t.same(data, TARGET, 'should get the Call target data');
});
(0, tstest_1.test)('getCallTarget()', async (t) => {
    var _a;
    const TARGET = 0x42;
    const METHOD_NAME = 'testMethod';
    class Test {
        [_a = METHOD_NAME]() { return (0, ret_js_1.Ret)(); }
    }
    __decorate([
        (0, call_js_1.Call)(TARGET),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Test.prototype, _a, null);
    const instance = new Test();
    const data = (0, metadata_call_js_1.getMetadataCall)(instance, METHOD_NAME);
    t.same(data, TARGET, 'should get Call target data');
});
(0, tstest_1.test)('getCallTarget() with agent target', async (t) => {
    var _a;
    const TARGET = {
        funcName: 'test',
        type: 'agent',
    };
    const METHOD_NAME = 'testMethod';
    class Test {
        [_a = METHOD_NAME]() { return (0, ret_js_1.Ret)(); }
    }
    __decorate([
        (0, call_js_1.Call)(TARGET),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Test.prototype, _a, null);
    const instance = new Test();
    const data = (0, metadata_call_js_1.getMetadataCall)(instance, METHOD_NAME);
    t.same(data, TARGET, 'should get Call target data by agent target');
});
//# sourceMappingURL=call.spec.js.map