#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const hook_js_1 = require("./hook.js");
(0, tstest_1.test)('Hook with metadata', async (t) => {
    const TARGET = 0x42;
    class Test {
        method() { }
    }
    __decorate([
        (0, hook_js_1.Hook)(TARGET),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Test.prototype, "method", null);
    const instance = new Test();
    const data = Reflect.getMetadata(hook_js_1.HOOK_TARGET_SYMBOL, instance, 'method');
    /* eslint-disable no-sparse-arrays */
    t.same(data, TARGET, 'should get the hook target data');
});
(0, tstest_1.test)('getHookTarget()', async (t) => {
    const TARGET = 0x42;
    class Test {
        method() { }
    }
    __decorate([
        (0, hook_js_1.Hook)(TARGET),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Test.prototype, "method", null);
    const instance = new Test();
    const data = (0, hook_js_1.getMetadataHook)(instance, 'method');
    t.same(data, TARGET, 'should get hook target data');
});
//# sourceMappingURL=hook.spec.js.map