"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParamType = void 0;
const config_js_1 = require("../../config.js");
const metadata_param_type_js_1 = require("./metadata-param-type.js");
const guard_param_type_js_1 = require("./guard-param-type.js");
function ParamType(nativeType, ...pointerTypeList) {
    config_js_1.log.verbose('Sidecar', '@ParamType(%s%s)', nativeType, pointerTypeList.length > 0
        ? `, [${pointerTypeList.join(',')}]`
        : '');
    return function paramTypeDecorator(target, propertyKey, parameterIndex) {
        config_js_1.log.verbose('Sidecar', '@ParamType(%s%s) paramTypeDecorator (%s, %s, %s)', nativeType, pointerTypeList.length > 0
            ? `, [${pointerTypeList.join(',')}]`
            : '', target.constructor.name, propertyKey, parameterIndex);
        (0, guard_param_type_js_1.guardParamType)(target, propertyKey, parameterIndex, nativeType, pointerTypeList);
        (0, metadata_param_type_js_1.updateMetadataParamType)(target, propertyKey, parameterIndex, [nativeType, ...pointerTypeList]);
    };
}
exports.ParamType = ParamType;
//# sourceMappingURL=param-type.js.map