"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateMetadataRetType = exports.getMetadataRetType = void 0;
const config_js_1 = require("../../config.js");
const constants_js_1 = require("./constants.js");
function updateMetadataRetType(target, propertyKey, typeChain) {
    config_js_1.log.verbose('Sidecar', 'updateMetadataRetType(%s, %s, %s)', target.name, propertyKey, JSON.stringify(typeChain));
    // Update the parameter names
    Reflect.defineMetadata(constants_js_1.RET_TYPE_SYMBOL, typeChain, target, propertyKey);
}
exports.updateMetadataRetType = updateMetadataRetType;
function getMetadataRetType(target, propertyKey) {
    // Pull the array of parameter names
    const retTypeChain = Reflect.getMetadata(constants_js_1.RET_TYPE_SYMBOL, target, propertyKey);
    return retTypeChain;
}
exports.getMetadataRetType = getMetadataRetType;
//# sourceMappingURL=metadata-ret-type.js.map