"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateMetadataSidecar = exports.getMetadataSidecar = void 0;
const config_js_1 = require("../../config.js");
const constants_js_1 = require("./constants.js");
function updateMetadataSidecar(target, view) {
    config_js_1.log.verbose('Sidecar', 'updateMetadataSidecar(%s, "%s...")', target.name, JSON.stringify(view).substr(0, 20));
    // log.silly('Sidecar', 'updateMetadataSidecar(%s, %s)',
    //   target.name,
    //   JSON.stringify(view)
    // )
    // Update the parameter names
    Reflect.defineMetadata(constants_js_1.SIDECAR_SYMBOL, view, target);
}
exports.updateMetadataSidecar = updateMetadataSidecar;
function getMetadataSidecar(target) {
    // Pull the array of parameter names
    const view = Reflect.getMetadata(constants_js_1.SIDECAR_SYMBOL, target);
    return view;
}
exports.getMetadataSidecar = getMetadataSidecar;
//# sourceMappingURL=metadata-sidecar.js.map