#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const module_name_js_1 = require("./module-name.js");
(0, tstest_1.test)('moduleName() spawn with linux path', async (t) => {
    const DATA = {
        target: [
            '/usr/bin/command',
            ['arg1'],
        ],
        type: 'spawn',
    };
    const EXPECT = 'command';
    const result = module_name_js_1.moduleName.call({
        sidecarTarget: DATA,
    });
    t.equal(result, EXPECT, 'should get module name from spawn for linux path');
});
(0, tstest_1.test)('moduleName() spawn with windows path', async (t) => {
    const DATA = {
        target: [
            'C:\\Program Files\\folder\\command.exe',
            ['arg1'],
        ],
        type: 'spawn',
    };
    const EXPECT = 'command.exe';
    const result = module_name_js_1.moduleName.call({
        sidecarTarget: DATA,
    });
    t.equal(result, EXPECT, 'should get module name from spawn for windows path');
});
//# sourceMappingURL=module-name.spec.js.map