#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
const native_ret_type_js_1 = require("./native-ret-type.js");
(0, tstest_1.test)('nativeRetType()', async (t) => {
    const fixture = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    // console.log(JSON.stringify(fixture.nativeFunctionList, null, 2))
    const result = fixture.nativeFunctionList
        .map(x => Object.values(x))
        .flat()
        .map(x => native_ret_type_js_1.nativeRetType.call(x));
    // console.log(result)
    const EXPECTED_RESULT = [
        "'pointer'",
        "'pointer'",
        "'pointer'",
        "'void'",
        "'void'",
    ];
    t.same(result, EXPECTED_RESULT, 'should list the native ret type correctly.');
});
//# sourceMappingURL=native-ret-type.spec.js.map