import fs from 'fs/promises';
async function extractClassNameList(url) {
    const content = await fs.readFile(url, 'utf-8');
    return extractClassNameListFromSource(content);
}
async function extractClassNameListFromSource(source) {
    /**
     * Extract the @Sidecar decorated classes
     */
    const REGEXP = /@Sidecar\s*\(.*?\)\s*(?:export)?\s*class\s+([A-Za-z0-9\-_]+)\s+/sg;
    return Array.from(source.matchAll(REGEXP)).map(m => m[1]);
}
export { extractClassNameListFromSource, extractClassNameList, };
//# sourceMappingURL=extract-class-names.js.map