import { log, } from '../../config.js';
import { updateMetadataParamType } from './metadata-param-type.js';
import { guardParamType } from './guard-param-type.js';
function ParamType(nativeType, ...pointerTypeList) {
    log.verbose('Sidecar', '@ParamType(%s%s)', nativeType, pointerTypeList.length > 0
        ? `, [${pointerTypeList.join(',')}]`
        : '');
    return function paramTypeDecorator(target, propertyKey, parameterIndex) {
        log.verbose('Sidecar', '@ParamType(%s%s) paramTypeDecorator (%s, %s, %s)', nativeType, pointerTypeList.length > 0
            ? `, [${pointerTypeList.join(',')}]`
            : '', target.constructor.name, propertyKey, parameterIndex);
        guardParamType(target, propertyKey, parameterIndex, nativeType, pointerTypeList);
        updateMetadataParamType(target, propertyKey, parameterIndex, [nativeType, ...pointerTypeList]);
    };
}
export { ParamType };
//# sourceMappingURL=param-type.js.map