export interface SidecarPayloadLog {
    type: 'log';
    payload: {
        level: string;
        message: string;
        prefix: string;
    };
}
export interface SidecarPayloadHook {
    type: 'hook';
    payload: {
        method: string;
        args: {
            [k: string]: null | string | number;
        };
    };
}
export declare type SidecarPayload = SidecarPayloadHook | SidecarPayloadLog;
export declare type SidecarPayloadType = SidecarPayload['type'];
declare const isSidecarPayloadLog: (payload: SidecarPayload) => payload is SidecarPayloadLog;
declare const isSidecarPayloadHook: (payload: SidecarPayload) => payload is SidecarPayloadHook;
export { isSidecarPayloadHook, isSidecarPayloadLog, };
//# sourceMappingURL=payload-schemas.d.ts.map